using System;
using System.Collections.Generic;

namespace Adaptation.FileHandlers.json;

public class DataSet
{

    public string Operator { get; }
    public DateTime DateTime { get; }
    public string Finish { get; }
    public string Orientation { get; }
    public string NorthProbeID { get; }
    public string SouthProbeID { get; }
    public string Polarity { get; }
    public double ContactRadius { get; }
    public double ProbeSpacing { get; }
    public double Load { get; }
    public double XStep { get; }
    // public string SampleSet { get; }
    public string Name { get; }
    public string PlateId { get; }
    public string Type { get; }
    public int PointsPerSample { get; }
    public int NumberOfPairs { get; }
    public List<Position> Positions { get; }

    public DataSet(string @operator,
                   DateTime dateTime,
                   string finish,
                   string orientation,
                   string northProbeID,
                   string southProbeID,
                   string polarity,
                   double contactRadius,
                   double probeSpacing,
                   double load,
                   double xStep,
                   string name,
                   string plateId,
                   string type,
                   int pointsPerSample,
                   int numberOfPairs,
                   List<Position> positions)
    {
        Operator = @operator;
        DateTime = dateTime;
        Finish = finish;
        Orientation = orientation;
        NorthProbeID = northProbeID;
        SouthProbeID = southProbeID;
        Polarity = polarity;
        ContactRadius = contactRadius;
        ProbeSpacing = probeSpacing;
        Load = load;
        XStep = xStep;
        Name = name;
        PlateId = plateId;
        Type = type;
        PointsPerSample = pointsPerSample;
        NumberOfPairs = numberOfPairs;
        Positions = positions;
    }

}