using System;
using System.Collections.Generic;

namespace Adaptation.FileHandlers.json;

public class Info
{

    public string Operator { get; }
    public string SampleName { get; }
    public string SoftwareVersion { get; }
    public DateTime DateTime { get; }
    public string SystemId { get; }
    public string SystemSite { get; }
    public int SamplePosition { get; }
    public int Units { get; }
    public int CommentLength { get; }
    public List<string> Comments { get; }

    internal Info(csv.Info info)
    {
        Operator = info.Operator;
        SampleName = info.SampleName;
        SoftwareVersion = info.SoftwareVersion;
        DateTime = DateTime.Parse(info.DateTime);
        SystemId = info.SystemId;
        SystemSite = info.SystemSite;
        SamplePosition = int.Parse(info.SamplePosition);
        Units = int.Parse(info.Units);
        CommentLength = int.Parse(info.CommentLength);
        Comments = info.Comments;
    }

}