namespace Adaptation.FileHandlers.json;

public class Layer
{

    public int FirstPoint { get; }
    public int? LastPoint { get; }
    public string Type { get; }
    public string Smoothing { get; }
    public string Apply { get; }
    public int SOrder { get; }
    public int GOrder { get; }
    public string Correction { get; }
    public string Conversion { get; }
    public string JunctionOption { get; }
    public int JunctionConstant { get; }
    public double CurrentDensity { get; }
    public string M1M2Tolerance { get; }
    public string Sheet { get; }
    public string Dose { get; }

    public Layer(int firstPoint,
                 int? lastPoint,
                 string type,
                 string smoothing,
                 string apply,
                 int sOrder,
                 int gOrder,
                 string correction,
                 string conversion,
                 string junctionOption,
                 int junctionConstant,
                 double currentDensity,
                 string m1M2Tolerance,
                 string sheet,
                 string dose)
    {
        FirstPoint = firstPoint;
        LastPoint = lastPoint;
        Type = type;
        Smoothing = smoothing;
        Apply = apply;
        SOrder = sOrder;
        GOrder = gOrder;
        Correction = correction;
        Conversion = conversion;
        JunctionOption = junctionOption;
        JunctionConstant = junctionConstant;
        CurrentDensity = currentDensity;
        M1M2Tolerance = m1M2Tolerance;
        Sheet = sheet;
        Dose = dose;
    }

}