using System;

namespace Adaptation.FileHandlers.json;

public class Log10
{

#nullable enable

    public double Depth { get; }
    public double ResistanceRaw { get; }
    public double? ResistanceEdited { get; }
    public double? Resistivity { get; }
    public double? Concentration { get; }

    public Log10(double depth,
                             double raw,
                             double? edited,
                             double? resistivity,
                             double? cd)
    {
        Depth = Math.Log10(depth);
        ResistanceRaw = Math.Log10(raw);
        ResistanceEdited = edited is null ? null : Math.Log10(edited.Value);
        Resistivity = resistivity is null ? null : Math.Log10(resistivity.Value);
        Concentration = cd is null ? null : Math.Log10(cd.Value);
    }

}