namespace Adaptation.FileHandlers.json;

public class ProfilePoint
{

#nullable enable

    public int Number { get; }
    public double Depth { get; }
    public double ResistanceRaw { get; }
    public double? ResistanceEdited { get; }
    public double? Resistivity { get; }
    public double? Concentration { get; }
    public double? DeltaPercent { get; }
    public ProfilePoint? LastProfilePoint { get; }
    public Log10? Log10 { get; }

    public ProfilePoint(int number,
                        double depth,
                        double raw,
                        double? edited,
                        double? resistivity,
                        double? cd,
                        ProfilePoint? lastProfilePoint)
    {
        Number = number;
        Depth = depth;
        ResistanceRaw = raw;
        ResistanceEdited = edited;
        Resistivity = resistivity;
        Concentration = cd;
        DeltaPercent = lastProfilePoint is null ? null : (lastProfilePoint.ResistanceRaw - raw) / raw;
        LastProfilePoint = lastProfilePoint;
        Log10 = new
        (
            depth: depth,
            raw: raw,
            edited: edited,
            resistivity: resistivity,
            cd: cd
        );
    }

}